"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var imx_link_types_1 = require("@imtbl/imx-link-types");
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var _1 = require(".");
describe('ethToEth8', function () {
    test('calculates the correct amount', function () {
        var result = function_1.pipe(imx_link_types_1.PositiveNumberStringC.decode('1'), E.map(_1.ethToEth8), _1.valueOrThrow);
        expect(result.toString()).toEqual('10000000000');
    });
});
describe('eth8ToEth', function () {
    test('calculates the correct amount', function () {
        var result = function_1.pipe(imx_link_types_1.PositiveBigNumber.decode('1'), E.map(_1.eth8ToEth), _1.valueOrThrow);
        expect(result.toString()).toEqual('0.0000000001');
    });
});
describe('weiToEth8()', function () {
    test('Calculates the correct amount', function () {
        var qtyEthAsWeiOne = '100000000';
        var result = function_1.pipe(imx_link_types_1.PositiveBigNumber.decode(qtyEthAsWeiOne), E.map(_1.weiToEth8), _1.valueOrThrow);
        expect(result.toString()).toEqual('1');
    });
});
describe('amountToQuantizedAmount()', function () {
    test("Calculates quantized amount for 'GODS'", function () {
        var decimalGods = 18;
        var quantumGods = '100000000';
        var qtyGodsOne = Math.pow(10, decimalGods).toString();
        var result = function_1.pipe(imx_link_types_1.PositiveBigNumber.decode(qtyGodsOne), E.map(function (number) { return _1.amountToQuantizedAmount(number, quantumGods); }), _1.valueOrThrow);
        expect(result.toString()).toEqual('10000000000');
    });
    test("Calculates quantized amount for 'IMX'", function () {
        var decimalImx = 18;
        var quantumImx = '1';
        var qtyImxOne = Math.pow(10, decimalImx).toString();
        var result = function_1.pipe(imx_link_types_1.PositiveBigNumber.decode(qtyImxOne), E.map(function (number) { return _1.amountToQuantizedAmount(number, quantumImx); }), _1.valueOrThrow);
        expect(result.toString()).toEqual('1000000000000000000');
    });
});
//# sourceMappingURL=utils.test.js.map